<?php
/************************************************************************
 * Mailer-Project 0.2.1-FINAL                         Start: 03/22/2004 *
 * ==========================                   Last change: 06/28/2004 *
 *                                                                      *
 * -------------------------------------------------------------------- *
 * File              : ext-signup.php                                   *
 * -------------------------------------------------------------------- *
 * Short description : SignUp Campaignes                                *
 * -------------------------------------------------------------------- *
 * Kurzbeschreibung  : SignUp-Kampagnen                                 *
 * -------------------------------------------------------------------- *
 *                                                                      *
 * -------------------------------------------------------------------- *
 * $Revision::                                                        $ *
 * $Date::                                                            $ *
 * $Tag:: 0.2.1-FINAL                                                 $ *
 * $Author::                                                          $ *
 * -------------------------------------------------------------------- *
 * Copyright (c) 2003 - 2009 by Roland Haeder                           *
 * Copyright (c) 2009 - 2011 by Mailer Developer Team                   *
 * For more information visit: http://www.mxchange.org                  *
 *                                                                      *
 * This program is free software; you can redistribute it and/or modify *
 * it under the terms of the GNU General Public License as published by *
 * the Free Software Foundation; either version 2 of the License, or    *
 * (at your option) any later version.                                  *
 *                                                                      *
 * This program is distributed in the hope that it will be useful,      *
 * but WITHOUT ANY WARRANTY; without even the implied warranty of       *
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the        *
 * GNU General Public License for more details.                         *
 *                                                                      *
 * You should have received a copy of the GNU General Public License    *
 * along with this program; if not, write to the Free Software          *
 * Foundation, Inc., 51 Franklin St, Fifth Floor, Boston,               *
 * MA  02110-1301  USA                                                  *
 ************************************************************************/

// Some security stuff...
if (!defined('__SECURITY')) {
	exit();
} // END - if

// Version number
setThisExtensionVersion('0.0.0');

// Version history array (add more with , '0.1' and so on)
setExtensionVersionHistory(array('0.0.0'));

// This extension is in development (non-productive)
enableExtensionProductive(FALSE);

switch (getExtensionMode()) {
	case 'register': // Do stuff when installtion is running
		// Add dependeny on 'sponsor'
		addExtensionDependency('sponsor');

		// SignUp data
		addDropTableSql('signup_data');
		addCreateTableSql('signup_data', "
`signup_id` BIGINT (20) UNSIGNED NOT NULL AUTO_INCREMENT,
`signup_sponsor_id` BIGINT (20) UNSIGNED NOT NULL,
`signup_title` VARCHAR (255) NOT NULL DEFAULT '',
`signup_text` LONGTEXT NOT NULL,
`signup_welcome_text` TINYTEXT NOT NULL,
`signup_question` VARCHAR (255) NOT NULL DEFAULT '',
`signup_url` VARCHAR (255) NOT NULL DEFAULT '',
`signup_banner` VARCHAR (255) NOT NULL DEFAULT '',
`signup_bonus` FLOAT (20,5) UNSIGNED NOT NULL DEFAULT 0.00000,
`signup_start` TIMESTAMP NOT NULL DEFAULT '0000-00-00 00:00:00',
`signup_end` TIMESTAMP NOT NULL DEFAULT '0000-00-00 00:00:00',
`signup_expiration` TIMESTAMP NULL DEFAULT NULL,
`signup_amount` BIGINT (20) UNSIGNED NOT NULL DEFAULT 0,
`signup_counter` BIGINT (20) UNSIGNED NOT NULL DEFAULT 0,
`signup_points` FLOAT (20,5) UNSIGNED NOT NULL DEFAULT 0.00000,
`signup_active` ENUM('Y','N') NOT NULL DEFAULT 'N',
`signup_warn_expire` ENUM('Y','N') NOT NULL DEFAULT 'Y',
`signup_warn_amount` BIGINT (20) UNSIGNED NOT NULL DEFAULT 0,
`signup_warn_interval` BIGINT (20) UNSIGNED NOT NULL DEFAULT {%pipe,getOneDay%},
`signup_status` ENUM('PENDING','APPROVED','LOCKED','DELETED') NOT NULL DEFAULT 'PENDING',
`signup_clicks` BIGINT (20) UNSIGNED NOT NULL DEFAULT 0,
`signup_views` BIGINT (20) UNSIGNED NOT NULL DEFAULT 0,
INDEX (`signup_sponsor_id`),
PRIMARY KEY (`signup_id`)",
			'General sign-up data');

		// Users entered words
		addDropTableSql('signup_user_data');
		addCreateTableSql('signup_user_data', "
`id` BIGINT (20) UNSIGNED NOT NULL AUTO_INCREMENT,
`signup_id` BIGINT (20) UNSIGNED NOT NULL DEFAULT 0,
`signup_userid` BIGINT (20) UNSIGNED NOT NULL DEFAULT 0,
`signup_bonus` FLOAT (20,5) UNSIGNED NOT NULL DEFAULT 0.00000,
`signup_word` VARCHAR (255) NOT NULL DEFAULT '',
`signup_added` TIMESTAMP NULL DEFAULT CURRENT_TIMESTAMP,
`signup_status` ENUM('PENDING','APPROVED','DECLINED') NOT NULL DEFAULT 'PENDING',
UNIQUE `signup_user` (`signup_id`, `signup_userid`),
PRIMARY KEY (`id`)",
			'Sign-up -> user connection table');

		// Admin menu
		addAdminMenuSql('signup', NULL, 'SignUp-Aktionen', 'Richten Sie hier SignUp-Aktionen ein oder schalten Sie welche von Ihren Sponsoren frei.', 5);
		addAdminMenuSql('signup', 'add_signup', 'Hinzuf&uuml;gen', 'Neue SignUp-Aktion einrichten.', 1);
		addAdminMenuSql('signup', 'unlock_signup', 'SignUps freigeben', 'Freigeben von Sponsoren-Accounts und deren angemeldete SignUp-Aktionen.', 2);
		addAdminMenuSql('signup', 'list_signup', 'Auflisten', 'Alle SignUp-Aktionen auflisten, &auml;dern, l&ouml;schen und eine einfache Statistik dazu anzeigen.', 3);

		// Guest menu
		addGuestMenuSql('main', 'signup', 'SignUp-Aktionen', 7);

		// Member menu
		addMemberMenuSql('main', 'signup', 'SignUp-Aktionen', 7);

		// Add entry to sponsor registry
		addExtensionSql("INSERT INTO `{?_MYSQL_PREFIX?}_sponsor_registry` (`ext_name`, `is_active`, `admin_id`, `stamp_added`) VALUES ('signup', 'N', {%%pipe,getCurrentAdminId%%}, NOW())");

		// Sponsor menu
		addSponsorMenuSql('actions', 'signup', 'SignUp-Aktion', 'N', 2);
		break;

	case 'remove': // Do stuff when removing extension
		// Remove tables
		addDropTableSql('signup_data');
		addDropTableSql('signup_user_data');

		// Remove menu entries
		addExtensionSql("DELETE LOW_PRIORITY FROM `{?_MYSQL_PREFIX?}_admin_menu` WHERE `action`='signup' LIMIT 4");
		addExtensionSql("DELETE LOW_PRIORITY FROM `{?_MYSQL_PREFIX?}_guest_menu` WHERE `what`='signup' LIMIT 1");
		addExtensionSql("DELETE LOW_PRIORITY FROM `{?_MYSQL_PREFIX?}_member_menu` WHERE `what`='signup' LIMIT 1");

		// Add entry for registry removal
		addExtensionSql("DELETE LOW_PRIORITY FROM `{?_MYSQL_PREFIX?}_sponsor_registry` WHERE `ext_name`='signup' LIMIT 1");

		// ... and entry from sponsor menu
		addExtensionSql("DELETE LOW_PRIORITY FROM `{?_MYSQL_PREFIX?}_sponsor_menu` WHERE `what`='signup' LIMIT 1");
		break;

	case 'activate': // Do stuff when admin activates this extension
		// SQL commands to run
		addExtensionSql("UPDATE `{?_MYSQL_PREFIX?}_guest_menu` SET `locked`='N', visible='Y' WHERE `action`='signup' OR `what`='signup' LIMIT 4");
		addExtensionSql("UPDATE `{?_MYSQL_PREFIX?}_member_menu` SET `locked`='N', visible='Y' WHERE `what`='signup' LIMIT 1");
		break;

	case 'deactivate': // Do stuff when admin deactivates this extension
		// SQL commands to run
		addExtensionSql("UPDATE `{?_MYSQL_PREFIX?}_guest_menu` SET `locked`='Y', visible='N' WHERE `action`='signup' OR `what`='signup' LIMIT 4");
		addExtensionSql("UPDATE `{?_MYSQL_PREFIX?}_member_menu` SET `locked`='Y', visible='N' WHERE `what`='signup' LIMIT 1");
		break;

	case 'update': // Update an extension
		switch (getCurrentExtensionVersion()) {
			case '0.0.1': // SQL queries for v0.0.1
				addExtensionSql('');

				// Update notes (these will be set as task text!)
				setExtensionUpdateNotes('');
				break;
		} // END - switch
		break;

	case 'modify': // When the extension got modified
		break;

	case 'test': // For testing purposes
		break;

	case 'init': // Do stuff when extension is initialized
		break;

	default: // Unknown extension mode
		logDebugMessage(__FILE__, __LINE__, sprintf("Unknown extension mode %s in extension %s detected.", getExtensionMode(), getCurrentExtensionName()));
		break;
} // END - switch

// [EOF]
?>
