<?php
/************************************************************************
 * Mailer v0.2.1-FINAL                                Start: 10/12/2003 *
 * ===================                          Last change: 11/29/2005 *
 *                                                                      *
 * -------------------------------------------------------------------- *
 * File              : what-config_register2.php                        *
 * -------------------------------------------------------------------- *
 * Short description : Setup for the registration form                  *
 * -------------------------------------------------------------------- *
 * Kurzbeschreibung  : Einstellungen fuer das Anmeldeformular           *
 * -------------------------------------------------------------------- *
 *          Adapted from what-config_reg.php                            *
 * -------------------------------------------------------------------- *
 * $Revision::                                                        $ *
 * $Date::                                                            $ *
 * $Tag:: 0.2.1-FINAL                                                 $ *
 * $Author::                                                          $ *
 * -------------------------------------------------------------------- *
 * Copyright (c) 2003 - 2009 by Roland Haeder                           *
 * Copyright (c) 2009 - 2012 by Mailer Developer Team                   *
 * For more information visit: http://mxchange.org                      *
 *                                                                      *
 * This program is free software; you can redistribute it and/or modify *
 * it under the terms of the GNU General Public License as published by *
 * the Free Software Foundation; either version 2 of the License, or    *
 * (at your option) any later version.                                  *
 *                                                                      *
 * This program is distributed in the hope that it will be useful,      *
 * but WITHOUT ANY WARRANTY; without even the implied warranty of       *
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the        *
 * GNU General Public License for more details.                         *
 *                                                                      *
 * You should have received a copy of the GNU General Public License    *
 * along with this program; if not, write to the Free Software          *
 * Foundation, Inc., 51 Franklin St, Fifth Floor, Boston,               *
 * MA  02110-1301  USA                                                  *
 ************************************************************************/

// Some security stuff...
if ((!defined('__SECURITY')) || (!isAdmin())) {
	die();
} // END - if

// Add description as navigation point
addYouAreHereLink('admin', __FILE__);

if (isFormSent('save_config')) {
	// Calculate timestamp from selections...
	setPostRequestElement('ip_timeout', createEpocheTimeFromSelections('ip_timeout', postRequestArray()));
	setPostRequestElement('least_cats', round(postRequestElement('least_cats')));

	// Save settings
	adminSaveSettingsFromPostData();
} else {
	// Remember stuff in constants
	$content['display_refid']                    = addSelectionBox('yn', getDisplayRefid()                 , 'display_refid');
	$content['ip_timeout']                       = createConfigurationTimeSelections('ip_timeout', 'Dhm');
	$content['check_double_email']               = addSelectionBox('yn', getCheckDoubleEmail()             , 'check_double_email');
	$content['register_default']                 = addSelectionBox('yn', getRegisterDefault()              , 'register_default');
	$content['register_generate_password_empty'] = addSelectionBox('yn', getRegisterGeneratePasswordEmpty(), 'register_generate_password_empty');

	// Load normal template
	loadTemplate('admin_config_register2', FALSE, $content);
}

// [EOF]
?>
